=== debian/changelog ===
glfw3 (3.4-4) unstable; urgency=medium

  * d/control: Stop build depending on libosmesa6-dev. (Closes: #1116329)

 -- James Cowgill <jcowgill@debian.org>  Thu, 25 Sep 2025 22:39:00 +0100

glfw3 (3.4-3) unstable; urgency=medium

  * d/rules: Build with -D_DEFAULT_SOURCE to fix Hurd.
  * d/libglfw3.symbols: Only include wayland symbols on Linux.

 -- James Cowgill <jcowgill@debian.org>  Fri, 29 Nov 2024 18:35:11 +0000

glfw3 (3.4-2) unstable; urgency=medium

  * d/control: Bump standards version.
  * d/tests: Bump minimum CMake version to 3.25. (Closes: #1087856)

 -- James Cowgill <jcowgill@debian.org>  Tue, 19 Nov 2024 17:20:47 +0000

glfw3 (3.4-1) unstable; urgency=medium

  [ Michel Le Bihan ]
  * New upstream release. (Closes: #1067416)
  * Update debian/copyright.
  * Update wayland platform flag name in debian/rules.
  * d/*.symbols: Add new symbols exported by 3.4.

  [ James Cowgill ]
  * Remove separate wayland package build. (Closes: #1067512)
  * d/copyright: Update debian copyright.
  * d/control:
    - Drop ancient conflicts on libglfw-dev.
    - Drop extra wayland build-dependencies.
    - Drop useless Pre-Depends fields.
    - Replace obsolete -dev dependencies.
  * d/libglfw3-doc.links: Remove jquery symlink.
  * d/patches: Drop all patches.
  * d/rules:
    - Drop as-needed flags.
    - Wrangle dynamic dependencies.
  * d/tests: Mark tests as superficial.

 -- James Cowgill <jcowgill@debian.org>  Mon, 25 Mar 2024 16:29:18 +0000
