=== debian/control ===
Source: glfw3
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Mahyuddin Susanto <udienz@ubuntu.com>,
 Roman Valov <roman.valov@gmail.com>,
 James Cowgill <jcowgill@debian.org>,
Build-Depends:
 cmake (>= 3.0),
 debhelper-compat (= 13),
 libdecor-0-dev [linux-any],
 libegl-dev,
 libgl-dev,
 libglx-dev,
 libgles-dev,
 libopengl-dev,
 libvulkan-dev [linux-any],
 libwayland-dev [linux-any],
 libx11-dev,
 libx11-xcb-dev,
 libxcursor-dev,
 libxi-dev,
 libxinerama-dev,
 libxkbcommon-dev,
 libxrandr-dev,
 pkgconf [linux-any],
Build-Depends-Indep:
 doxygen,
Standards-Version: 4.7.0
Homepage: https://www.glfw.org/
Vcs-Git: https://salsa.debian.org/games-team/glfw3.git
Vcs-Browser: https://salsa.debian.org/games-team/glfw3
Rules-Requires-Root: no

Package: libglfw3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ${shlibs:Suggests},
Breaks:
 libglfw3-wayland (<< 3.4-1~),
Replaces:
 libglfw3-wayland (<< 3.4-1~),
Description: portable library for OpenGL, window and input
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides the shared library built with the X11 and
 Wayland backends.

Package: libglfw3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libgl-dev,
 libglfw3 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libegl-dev,
 libglx-dev,
 libvulkan-dev,
 libwayland-dev,
 libx11-dev,
 libxrandr-dev,
Suggests:
 libglfw3-doc,
Description: portable library for OpenGL, window and input (development files)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides development files.

Package: libglfw3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: portable library for OpenGL, window and input (documentation)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This package provides documentation.

Package: libglfw3-wayland
Section: oldlibs
Architecture: linux-any
Multi-Arch: same
Depends:
 libglfw3,
 ${misc:Depends},
Description: portable library for OpenGL, window and input (transitional package)
 GLFW is an Open Source, multi-platform library for creating
 windows with OpenGL contexts and managing input and events.
 It is easy to integrate into existing applications and does
 not lay claim to the main loop.
 .
 This is a transitional package. It can safely be removed.
